#include "FamiAudio.h"

static int null_dmc_reader( void*, cpu_addr_t )
{
	return 0x55; // causes dmc sample to be flat
}

FamiAudio::FamiAudio()
{
	time = 0;
	frame_length = 29780;
	apu.dmc_reader( null_dmc_reader, NULL );
}

FamiAudio::~FamiAudio()
{
}

blargg_err_t FamiAudio::set_timings( long sample_rate, long clock_rate, long frame_rate )
{
	frame_length=clock_rate/frame_rate;
	apu.output(&buf);
	vrc6.output(&buf);
	buf.clock_rate( clock_rate );
	return buf.sample_rate( sample_rate );
}

void FamiAudio::write_register( cpu_addr_t addr, int data )
{
	int osc,reg;

	if(addr<0x8000)
	{
		apu.write_register( clock(), addr, data );
	}
	else
	{
		osc=(addr-0x9000)/0x1000;
		reg=addr&3;

		vrc6.write_osc(clock(),osc,reg,data);
	}
}

void FamiAudio::end_frame()
{
	time = 0;
	frame_length ^= 1;
	apu.end_frame (frame_length);
	vrc6.end_frame(frame_length);
	buf.end_frame (frame_length);
}

long FamiAudio::samples_avail() const
{
	return buf.samples_avail();
}

long FamiAudio::read_samples( sample_t* p, long s )
{
	return buf.read_samples( p, s );
}

